<?php
declare (strict_types=1);

namespace App\Entity\Booking;

use ApiPlatform\Metadata\Get;
use ApiPlatform\Metadata\ApiResource;
use App\Entity\Access\Access;
use App\Entity\Billing\BillLine;
use App\Entity\Billing\EducationalProjectIntangible;
use App\Entity\Billing\EducationalProjectPayer;
use App\Entity\Core\File;
use App\Entity\Core\Tagg;
use App\Entity\Organization\Organization;
use App\Entity\Place\Place;
use App\Entity\Place\Room;
//use DH\Auditor\Provider\Doctrine\Auditing\Annotation\Auditable;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @todo : A la suite de la migration, il faut supprimer le nom de la table pour avoir une table EducationalProject, et supprimer l'attribut discr.
 * @todo : migration table tag_booking
 * Classe ... qui ...
 */
#[ApiResource(
    operations: [
        new Get(
            security: 'is_granted(\'ROLE_ADMIN\') and object.getOrganization().getId() == user.getOrganization().getId()'
        )
    ]
)]
//#[Auditable]
#[ORM\Table(name: 'Booking')]
#[ORM\Entity]
class EducationalProject extends AbstractBooking
{
    #[ORM\Column(length: 255, nullable: false)]
    private string $discr = 'educationalproject';

    #[ORM\OneToMany(mappedBy: 'event', targetEntity: EducationalProjectRecur::class, cascade: ['persist'], orphanRemoval: true)]
    private Collection $eventRecur;

    #[ORM\OneToMany(mappedBy: 'parent', targetEntity: EducationalProject::class, orphanRemoval: true)]
    private Collection $timeline;

    #[ORM\ManyToOne(inversedBy: 'timeline')]
    private EducationalProject $parent;

    #[ORM\ManyToOne(inversedBy: 'educationalProjects')]
    #[ORM\JoinColumn(nullable: false)]
    protected Organization $organization;

    #[ORM\ManyToOne(inversedBy: 'silentPartners')]
    #[ORM\JoinColumn(referencedColumnName: 'id', nullable: true, onDelete: 'SET NULL')]
    private Access $silentPartner;

    #[ORM\ManyToOne(inversedBy: 'educationalProjects')]
    #[ORM\JoinColumn(referencedColumnName: 'id', nullable: true, onDelete: 'SET NULL')]
    private EducationalProjectPublic $public;

    #[ORM\ManyToOne(inversedBy: 'operationalPartners')]
    #[ORM\JoinColumn(referencedColumnName: 'id', nullable: true, onDelete: 'SET NULL')]
    private Access $operationalPartner;

    #[ORM\ManyToMany(targetEntity: Access::class)]
    #[ORM\JoinTable(name: 'educationalproject_financier')]
    private Collection $financiers;

    #[ORM\ManyToMany(targetEntity: File::class)]
    private Collection $files;

    #[ORM\OneToMany(mappedBy: 'educationalProject', targetEntity: EducationalProjectIntangible::class, cascade: ['persist'], orphanRemoval: true)]
    private Collection $educationalProjectIntangibles;

    #[ORM\OneToMany(mappedBy: 'educationalProjectReceiver', targetEntity: EducationalProjectPayer::class, cascade: ['persist'], orphanRemoval: true)]
    private Collection $billingReceivers;

    #[ORM\OneToMany(mappedBy: 'educationalProject', targetEntity: BillLine::class, orphanRemoval: true)]
    private Collection $billLines;

    #[ORM\OneToMany(mappedBy: 'educationalProject', targetEntity: AttendanceBooking::class, cascade: ['persist'], orphanRemoval: true)]
    #[ORM\JoinColumn(nullable: false)]
    private Collection $attendanceBooking;

    #[ORM\ManyToOne(inversedBy: 'educationalProjects')]
    #[ORM\JoinColumn(referencedColumnName: 'id', nullable: true, onDelete: 'SET NULL')]
    protected Place $place;

    #[ORM\ManyToOne(inversedBy: 'educationalProjects')]
    #[ORM\JoinColumn(referencedColumnName: 'id', nullable: true, onDelete: 'SET NULL')]
    protected Room $room;

    #[ORM\ManyToMany(targetEntity: Access::class, inversedBy: 'educationalProjectOrganizers')]
    #[ORM\JoinTable(name: 'booking_organizer')]
    #[ORM\JoinColumn(name: 'booking_id', referencedColumnName: 'id')]
    #[ORM\InverseJoinColumn(name: 'organizer_id', referencedColumnName: 'id')]
    private Collection $organizer;

    #[ORM\ManyToMany(targetEntity: Tagg::class, inversedBy: 'educationalProjects', cascade: ['persist'])]
    #[ORM\JoinTable(name: 'tag_booking')]
    #[ORM\JoinColumn(name: 'booking_id', referencedColumnName: 'id')]
    #[ORM\InverseJoinColumn(name: 'tag_id', referencedColumnName: 'id')]
    private Collection $tags;

    public function __construct()
    {
        $this->eventRecur = new ArrayCollection();
        $this->timeline = new ArrayCollection();
        $this->financiers = new ArrayCollection();
        $this->files = new ArrayCollection();
        $this->educationalProjectIntangibles = new ArrayCollection();
        $this->billingReceivers = new ArrayCollection();
        $this->billLines = new ArrayCollection();
        $this->attendanceBooking = new ArrayCollection();
        $this->organizer = new ArrayCollection();
        $this->tags = new ArrayCollection();
    }

    public function getDiscr(): ?string
    {
        return $this->discr;
    }

    public function setDiscr(string $discr): self
    {
        $this->discr = $discr;
        return $this;
    }

    /**
     * @return Collection<int, EducationalProjectRecur>
     */
    public function getEventRecur(): Collection
    {
        return $this->eventRecur;
    }

    public function addEventRecur(EducationalProjectRecur $eventRecur): self
    {
        if (!$this->eventRecur->contains($eventRecur)) {
            $this->eventRecur[] = $eventRecur;
            $eventRecur->setEvent($this);
        }
        return $this;
    }

    public function removeEventRecur(EducationalProjectRecur $eventRecur): self
    {
        if ($this->eventRecur->removeElement($eventRecur)) {
            // set the owning side to null (unless already changed)
            if ($eventRecur->getEvent() === $this) {
                $eventRecur->setEvent(null);
            }
        }
        return $this;
    }

    /**
     * @return Collection<int, EducationalProject>
     */
    public function getTimeline(): Collection
    {
        return $this->timeline;
    }

    public function addTimeline(EducationalProject $timeline): self
    {
        if (!$this->timeline->contains($timeline)) {
            $this->timeline[] = $timeline;
            $timeline->setParent($this);
        }
        return $this;
    }

    public function removeTimeline(EducationalProject $timeline): self
    {
        if ($this->timeline->removeElement($timeline)) {
            // set the owning side to null (unless already changed)
            if ($timeline->getParent() === $this) {
                $timeline->setParent(null);
            }
        }
        return $this;
    }

    public function getParent(): ?self
    {
        return $this->parent;
    }

    public function setParent(?self $parent): self
    {
        $this->parent = $parent;
        return $this;
    }

    public function getOrganization(): ?Organization
    {
        return $this->organization;
    }

    public function setOrganization(?Organization $organization): self
    {
        $this->organization = $organization;
        return $this;
    }

    public function getSilentPartner(): ?Access
    {
        return $this->silentPartner;
    }

    public function setSilentPartner(?Access $silentPartner): self
    {
        $this->silentPartner = $silentPartner;
        return $this;
    }

    public function getPublic(): ?EducationalProjectPublic
    {
        return $this->public;
    }

    public function setPublic(?EducationalProjectPublic $public): self
    {
        $this->public = $public;
        return $this;
    }

    public function getOperationalPartner(): ?Access
    {
        return $this->operationalPartner;
    }

    public function setOperationalPartner(?Access $operationalPartner): self
    {
        $this->operationalPartner = $operationalPartner;
        return $this;
    }

    /**
     * @return Collection<int, Access>
     */
    public function getFinanciers(): Collection
    {
        return $this->financiers;
    }

    public function addFinancier(Access $financier): self
    {
        if (!$this->financiers->contains($financier)) {
            $this->financiers[] = $financier;
        }
        return $this;
    }

    public function removeFinancier(Access $financier): self
    {
        $this->financiers->removeElement($financier);
        return $this;
    }

    /**
     * @return Collection<int, File>
     */
    public function getFiles(): Collection
    {
        return $this->files;
    }

    public function addFile(File $file): self
    {
        if (!$this->files->contains($file)) {
            $this->files[] = $file;
        }
        return $this;
    }

    public function removeFile(File $file): self
    {
        $this->files->removeElement($file);
        return $this;
    }

    /**
     * @return Collection<int, EducationalProjectIntangible>
     */
    public function getEducationalProjectIntangibles(): Collection
    {
        return $this->educationalProjectIntangibles;
    }

    public function addEducationalProjectIntangible(EducationalProjectIntangible $educationalProjectIntangible): self
    {
        if (!$this->educationalProjectIntangibles->contains($educationalProjectIntangible)) {
            $this->educationalProjectIntangibles[] = $educationalProjectIntangible;
            $educationalProjectIntangible->setEducationalProject($this);
        }
        return $this;
    }

    public function removeEducationalProjectIntangible(EducationalProjectIntangible $educationalProjectIntangible): self
    {
        if ($this->educationalProjectIntangibles->removeElement($educationalProjectIntangible)) {
            // set the owning side to null (unless already changed)
            if ($educationalProjectIntangible->getEducationalProject() === $this) {
                $educationalProjectIntangible->setEducationalProject(null);
            }
        }
        return $this;
    }

    /**
     * @return Collection<int, EducationalProjectPayer>
     */
    public function getBillingReceivers(): Collection
    {
        return $this->billingReceivers;
    }

    public function addBillingReceiver(EducationalProjectPayer $billingReceiver): self
    {
        if (!$this->billingReceivers->contains($billingReceiver)) {
            $this->billingReceivers[] = $billingReceiver;
            $billingReceiver->setEducationalProjectReceiver($this);
        }
        return $this;
    }

    public function removeBillingReceiver(EducationalProjectPayer $billingReceiver): self
    {
        if ($this->billingReceivers->removeElement($billingReceiver)) {
            // set the owning side to null (unless already changed)
            if ($billingReceiver->getEducationalProjectReceiver() === $this) {
                $billingReceiver->setEducationalProjectReceiver(null);
            }
        }
        return $this;
    }

    /**
     * @return Collection<int, BillLine>
     */
    public function getBillLines(): Collection
    {
        return $this->billLines;
    }

    public function addBillLine(BillLine $billLine): self
    {
        if (!$this->billLines->contains($billLine)) {
            $this->billLines[] = $billLine;
            $billLine->setEducationalProject($this);
        }
        return $this;
    }

    public function removeBillLine(BillLine $billLine): self
    {
        if ($this->billLines->removeElement($billLine)) {
            // set the owning side to null (unless already changed)
            if ($billLine->getEducationalProject() === $this) {
                $billLine->setEducationalProject(null);
            }
        }
        return $this;
    }

    /**
     * @return Collection<int, AttendanceBooking>
     */
    public function getAttendanceBooking(): Collection
    {
        return $this->attendanceBooking;
    }

    public function addAttendanceBooking(AttendanceBooking $attendanceBooking): self
    {
        if (!$this->attendanceBooking->contains($attendanceBooking)) {
            $this->attendanceBooking[] = $attendanceBooking;
            $attendanceBooking->setEducationalProject($this);
        }
        return $this;
    }

    public function removeAttendanceBooking(AttendanceBooking $attendanceBooking): self
    {
        if ($this->attendanceBooking->removeElement($attendanceBooking)) {
            // set the owning side to null (unless already changed)
            if ($attendanceBooking->getEducationalProject() === $this) {
                $attendanceBooking->setEducationalProject(null);
            }
        }
        return $this;
    }

    public function getPlace(): ?Place
    {
        return $this->place;
    }

    public function setPlace(?Place $place): self
    {
        $this->place = $place;
        return $this;
    }

    public function getRoom(): ?Room
    {
        return $this->room;
    }

    public function setRoom(?Room $room): self
    {
        $this->room = $room;
        return $this;
    }

    /**
     * @return Collection<int, Access>
     */
    public function getOrganizer(): Collection
    {
        return $this->organizer;
    }

    public function addOrganizer(Access $organizer): self
    {
        if (!$this->organizer->contains($organizer)) {
            $this->organizer[] = $organizer;
        }
        return $this;
    }

    public function removeOrganizer(Access $organizer): self
    {
        $this->organizer->removeElement($organizer);
        return $this;
    }

    /**
     * @return Collection<int, Tagg>
     */
    public function getTags(): Collection
    {
        return $this->tags;
    }

    public function addTag(Tagg $tag): self
    {
        if (!$this->tags->contains($tag)) {
            $this->tags[] = $tag;
        }
        return $this;
    }

    public function removeTag(Tagg $tag): self
    {
        $this->tags->removeElement($tag);
        return $this;
    }
}